<template>
    <div class="content-grid content-grid--subpage">
        <Breadcrumbs :title="t(`routes.admin.children.events.add.name`)" />
        <BackLinkTitle :title="t(`routes.admin.children.events.add.name`)" />
        <Card>
            <EventForm ref="eventFormRef" @formSubmit="handleSubmit" />
        </Card>
    </div>
</template>

<script lang="ts" setup>
    import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
    import BackLinkTitle from "@/components/layout/BackLinkTitle.vue";
    import EventForm from "@/components/events/EventForm.vue";
    import Card from "@/components/layout/Card.vue";
    import { ref } from "vue"
    import { useI18n } from "vue3-i18n";
    import { Event } from "@/types/entities";
    import { notifyError, notifySuccess } from "@/notify";
    import { useEventService } from "@/inversify.config";
    import { ICreateEventRequest } from "@/types/requests/createEventRequest";
    import { useRouter } from "vue-router";

    const { t } = useI18n()
    const router = useRouter();
    const eventService = useEventService();
    const eventFormRef = ref();
    console.log(t('admin.children.events.add'))

    async function handleSubmit(event: Event) {
        let succeededOrNotResponse = await eventService.createEvent(event as ICreateEventRequest)
        if (succeededOrNotResponse && succeededOrNotResponse.succeeded) {
            notifySuccess(t('validation.event.add.success'))
            setTimeout(() => {
                router.back();
            }, 1500);
        } else {
            console.log(succeededOrNotResponse);
            let errorMessages = succeededOrNotResponse.getErrorMessages('validation.event.add');
            if (errorMessages.length == 0)
                notifyError(t('validation.event.add.errorOccured'))
            else {
                notifyError(errorMessages[0])

            }
        }
    }
</script>
